/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.225 Revision 1.359
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.225 2006/02/18 10:50:10 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.359 2011/07/20 05:46:46 vapier Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# Author: Martin Schlemmer <azarah@gentoo.org> 15# Due to the nature of this eclass, some functions may have maintainers
6# 16# different from the overall eclass!
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 17
12inherit multilib portability 18inherit multilib portability
13 19
14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
16
17DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
18 21
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
21# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
22# must be an integer greater than zero. 25# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 31epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 33}
29 34
30# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
32# don't beep. 37# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 42ebeep() {
35 local n 43 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 46 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 48 echo -ne "\a"
41 sleep 1 49 sleep 1
42 done 50 done
43 fi 51 fi
44} 52}
45 53
46# This function generate linker scripts in /usr/lib for dynamic 54else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local lib libdir=$(get_libdir)
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 55
69 for lib in "${@}" ; do 56ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 58}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 59
77 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
78 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 62}
80 END_LDSCRIPT 63
81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
82 done 118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
83} 134}
84 135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
85 154
86# Default directory where patches are located 155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
87EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
88# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
89EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
90# Default options for patch 165# Default options for patch:
166# @CODE
91# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
92# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
169# -E - automatically remove empty files
170# @CODE
93EPATCH_OPTS="-g0 --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
95# and not the full path .. 175# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
97# Change the printed message for a single patch. 179# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
99# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
102# 186# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 188# arch naming style.
105EPATCH_FORCE="no" 189EPATCH_FORCE="no"
106 190
107# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
108# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
109# 199#
110# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
112# 202#
113# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
115# 205# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
125# 215#
126# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
127# 218#
128# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 220epatch() {
141 _epatch_draw_line() { 221 _epatch_draw_line() {
142 local i=0 str_length="" str_out="" 222 # create a line of same length as input string
143 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
144 # Handle calls that do not have args, or wc not being installed ... 224 echo "${1//?/=}"
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 } 225 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
159 local PIPE_CMD=""
160 local STDERR_TARGET="${T}/$$.out"
161 local PATCH_TARGET="${T}/$$.patch"
162 local PATCH_SUFFIX=""
163 local SINGLE_PATCH="no"
164 local x=""
165 226
166 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
167 228
168 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
169 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
170 local m="" 233 local m
171 for m in "$@" ; do 234 for m in "$@" ; do
172 epatch "${m}" 235 epatch "${m}"
173 done 236 done
174 return 0 237 return 0
175 fi 238 fi
176 239
177 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
178 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
179 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
180 246 set -- "$1"
181 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
182 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
183 250
184 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
185 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
186 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
187 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
256 # Re-use EPATCH_SOURCE as a search dir
257 epatch "${EPATCH_SOURCE}/$1"
258 return $?
259
260 else
261 # sanity check ... if it isn't a dir or file, wtf man ?
262 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
263 echo
264 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
265 eerror
266 eerror " ${EPATCH_SOURCE}"
267 eerror " ( ${EPATCH_SOURCE##*/} )"
268 echo
269 die "Cannot find \$EPATCH_SOURCE!"
270 fi
271
272 local PIPE_CMD
273 case ${EPATCH_SUFFIX##*\.} in
274 xz) PIPE_CMD="xz -dc" ;;
275 lzma) PIPE_CMD="lzma -dc" ;;
276 bz2) PIPE_CMD="bzip2 -dc" ;;
277 gz|Z|z) PIPE_CMD="gzip -dc" ;;
278 ZIP|zip) PIPE_CMD="unzip -p" ;;
279 *) ;;
280 esac
281
282 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
283
284 local x
285 for x in "$@" ; do
286 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
287 # didn't match anything, ignore continue on
288 [[ ! -f ${x} ]] && continue
289
290 local patchname=${x##*/}
291
292 # Apply single patches, or forced sets of patches, or
293 # patches with ARCH dependant names.
294 # ???_arch_foo.patch
295 # Else, skip this input altogether
296 local a=${patchname#*_} # strip the ???_
297 a=${a%%_*} # strip the _foo.patch
298 if ! [[ ${SINGLE_PATCH} == "yes" || \
299 ${EPATCH_FORCE} == "yes" || \
300 ${a} == all || \
301 ${a} == ${ARCH} ]]
188 then 302 then
189 local EPATCH_SOURCE="$1/*" 303 continue
304 fi
305
306 # Let people filter things dynamically
307 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
308 # let people use globs in the exclude
309 eshopts_push -o noglob
310
311 local ex
312 for ex in ${EPATCH_EXCLUDE} ; do
313 if [[ ${patchname} == ${ex} ]] ; then
314 eshopts_pop
315 continue 2
316 fi
317 done
318
319 eshopts_pop
320 fi
321
322 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
323 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
324 einfo "${EPATCH_SINGLE_MSG}"
325 else
326 einfo "Applying ${patchname} ..."
327 fi
190 else 328 else
191 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 329 einfo " ${patchname} ..."
192 fi 330 fi
193 else 331
194 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 332 # most of the time, there will only be one run per unique name,
195 then 333 # but if there are more, make sure we get unique log filenames
196 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 334 local STDERR_TARGET="${T}/${patchname}.out"
197 then 335 if [[ -e ${STDERR_TARGET} ]] ; then
198 EPATCH_SOURCE="$1" 336 STDERR_TARGET="${T}/${patchname}-$$.out"
337 fi
338
339 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
340
341 # Decompress the patch if need be
342 local count=0
343 local PATCH_TARGET
344 if [[ -n ${PIPE_CMD} ]] ; then
345 PATCH_TARGET="${T}/$$.patch"
346 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
347
348 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
349 echo
350 eerror "Could not extract patch!"
351 #die "Could not extract patch!"
352 count=5
353 break
199 fi 354 fi
355 else
356 PATCH_TARGET=${x}
357 fi
200 358
359 # Check for absolute paths in patches. If sandbox is disabled,
360 # people could (accidently) patch files in the root filesystem.
361 # Or trigger other unpleasantries #237667. So disallow -p0 on
362 # such patches.
363 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
364 if [[ -n ${abs_paths} ]] ; then
365 count=1
366 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
367 fi
368 # Similar reason, but with relative paths.
369 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
370 if [[ -n ${rel_paths} ]] ; then
371 eqawarn "QA Notice: Your patch uses relative paths '../'."
372 eqawarn " In the future this will cause a failure."
373 eqawarn "${rel_paths}"
374 fi
375
376 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
377 while [[ ${count} -lt 5 ]] ; do
378 # Generate some useful debug info ...
379 (
380 _epatch_draw_line "***** ${patchname} *****"
201 echo 381 echo
202 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 382 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
383 echo
384 _epatch_draw_line "***** ${patchname} *****"
385 ) >> "${STDERR_TARGET}"
386
387 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
388 (
389 _epatch_draw_line "***** ${patchname} *****"
390 echo
391 echo "ACTUALLY APPLYING ${patchname} ..."
392 echo
393 _epatch_draw_line "***** ${patchname} *****"
394 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
395 ) >> "${STDERR_TARGET}"
396
397 if [ $? -ne 0 ] ; then
398 echo
399 eerror "A dry-run of patch command succeeded, but actually"
400 eerror "applying the patch failed!"
401 #die "Real world sux compared to the dreamworld!"
402 count=5
403 fi
404 break
405 fi
406
407 : $(( count++ ))
408 done
409
410 # if we had to decompress the patch, delete the temp one
411 if [[ -n ${PIPE_CMD} ]] ; then
412 rm -f "${PATCH_TARGET}"
413 fi
414
415 if [[ ${count} -ge 5 ]] ; then
416 echo
417 eerror "Failed Patch: ${patchname} !"
418 eerror " ( ${PATCH_TARGET} )"
203 eerror 419 eerror
204 eerror " ${EPATCH_SOURCE}" 420 eerror "Include in your bugreport the contents of:"
205 eerror " ( ${EPATCH_SOURCE##*/} )" 421 eerror
422 eerror " ${STDERR_TARGET}"
206 echo 423 echo
207 die "Cannot find \$EPATCH_SOURCE!"
208 fi
209
210 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
211 fi
212
213 case ${EPATCH_SUFFIX##*\.} in
214 bz2)
215 PIPE_CMD="bzip2 -dc"
216 PATCH_SUFFIX="bz2"
217 ;;
218 gz|Z|z)
219 PIPE_CMD="gzip -dc"
220 PATCH_SUFFIX="gz"
221 ;;
222 ZIP|zip)
223 PIPE_CMD="unzip -p"
224 PATCH_SUFFIX="zip"
225 ;;
226 *)
227 PIPE_CMD="cat"
228 PATCH_SUFFIX="patch"
229 ;;
230 esac
231
232 if [ "${SINGLE_PATCH}" = "no" ]
233 then
234 einfo "${EPATCH_MULTI_MSG}"
235 fi
236 for x in ${EPATCH_SOURCE}
237 do
238 # New ARCH dependant patch naming scheme ...
239 #
240 # ???_arch_foo.patch
241 #
242 if [ -f ${x} ] && \
243 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
244 [ "${EPATCH_FORCE}" = "yes" ])
245 then
246 local count=0
247 local popts="${EPATCH_OPTS}"
248 local patchname=${x##*/}
249
250 if [ -n "${EPATCH_EXCLUDE}" ]
251 then
252 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
253 then
254 continue
255 fi
256 fi
257
258 if [ "${SINGLE_PATCH}" = "yes" ]
259 then
260 if [ -n "${EPATCH_SINGLE_MSG}" ]
261 then
262 einfo "${EPATCH_SINGLE_MSG}"
263 else
264 einfo "Applying ${patchname} ..."
265 fi
266 else
267 einfo " ${patchname} ..."
268 fi
269
270 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272
273 # Allow for prefix to differ ... im lazy, so shoot me :/
274 while [ "${count}" -lt 5 ]
275 do
276 # Generate some useful debug info ...
277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if [ "${PATCH_SUFFIX}" != "patch" ]
281 then
282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284 else
285 PATCH_TARGET="${x}"
286 fi
287
288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290
291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
293
294 if [ "${PATCH_SUFFIX}" != "patch" ]
295 then
296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
297 then
298 echo
299 eerror "Could not extract patch!"
300 #die "Could not extract patch!"
301 count=5
302 break
303 fi
304 fi
305
306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
307 then
308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
313
314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
316
317 if [ "$?" -ne 0 ]
318 then
319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
320 echo
321 eerror "A dry-run of patch command succeeded, but actually"
322 eerror "applying the patch failed!"
323 #die "Real world sux compared to the dreamworld!"
324 count=5
325 fi
326
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
328
329 break
330 fi
331
332 count=$((count + 1))
333 done
334
335 if [ "${PATCH_SUFFIX}" != "patch" ]
336 then
337 rm -f ${PATCH_TARGET}
338 fi
339
340 if [ "${count}" -eq 5 ]
341 then
342 echo
343 eerror "Failed Patch: ${patchname} !"
344 eerror " ( ${PATCH_TARGET} )"
345 eerror
346 eerror "Include in your bugreport the contents of:"
347 eerror
348 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
349 echo
350 die "Failed Patch: ${patchname}!" 424 die "Failed Patch: ${patchname}!"
351 fi 425 fi
352 426
353 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 427 # if everything worked, delete the patch log
354 428 rm -f "${STDERR_TARGET}"
355 eend 0 429 eend 0
356 fi
357 done 430 done
358 if [ "${SINGLE_PATCH}" = "no" ] 431
359 then 432 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
360 einfo "Done with patching" 433 : # everything worked
434}
435epatch_user() {
436 [[ $# -ne 0 ]] && die "epatch_user takes no options"
437
438 # don't clobber any EPATCH vars that the parent might want
439 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
440 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
441 EPATCH_SOURCE=${base}/${CTARGET}/${check}
442 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
443 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
444 if [[ -d ${EPATCH_SOURCE} ]] ; then
445 EPATCH_SOURCE=${EPATCH_SOURCE} \
446 EPATCH_SUFFIX="patch" \
447 EPATCH_FORCE="yes" \
448 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
449 epatch
450 return 0
361 fi 451 fi
452 done
453 return 1
362} 454}
363 455
456# @FUNCTION: emktemp
457# @USAGE: [temp dir]
458# @DESCRIPTION:
364# Cheap replacement for when debianutils (and thus mktemp) 459# Cheap replacement for when debianutils (and thus mktemp)
365# does not exist on the users system 460# does not exist on the users system.
366# vapier@gentoo.org
367#
368# Takes just 1 optional parameter (the directory to create tmpfile in)
369emktemp() { 461emktemp() {
370 local exe="touch" 462 local exe="touch"
371 [[ $1 == -d ]] && exe="mkdir" && shift 463 [[ $1 == -d ]] && exe="mkdir" && shift
372 local topdir=$1 464 local topdir=$1
373 465
375 [[ -z ${T} ]] \ 467 [[ -z ${T} ]] \
376 && topdir="/tmp" \ 468 && topdir="/tmp" \
377 || topdir=${T} 469 || topdir=${T}
378 fi 470 fi
379 471
380 if [[ -z $(type -p mktemp) ]] ; then 472 if ! type -P mktemp > /dev/null ; then
473 # system lacks `mktemp` so we have to fake it
381 local tmp=/ 474 local tmp=/
382 while [[ -e ${tmp} ]] ; do 475 while [[ -e ${tmp} ]] ; do
383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 476 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
384 done 477 done
385 ${exe} "${tmp}" || ${exe} -p "${tmp}" 478 ${exe} "${tmp}" || ${exe} -p "${tmp}"
386 echo "${tmp}" 479 echo "${tmp}"
387 else 480 else
481 # the args here will give slightly wierd names on BSD,
482 # but should produce a usable file on all userlands
388 if [[ ${exe} == "touch" ]] ; then 483 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \
390 && mktemp -p "${topdir}" \
391 || TMPDIR="${topdir}" mktemp -t tmp 484 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
392 else 485 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && mktemp -d "${topdir}" \
395 || TMPDIR="${topdir}" mktemp -dt tmp 486 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
396 fi
397 fi 487 fi
488 fi
398} 489}
399 490
491# @FUNCTION: egetent
492# @USAGE: <database> <key>
493# @MAINTAINER:
494# base-system@gentoo.org (Linux)
495# Joe Jezak <josejx@gmail.com> (OS X)
496# usata@gentoo.org (OS X)
497# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
498# @DESCRIPTION:
400# Small wrapper for getent (Linux), nidump (Mac OS X), 499# Small wrapper for getent (Linux),
500# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
401# and pw (FreeBSD) used in enewuser()/enewgroup() 501# and pw (FreeBSD) used in enewuser()/enewgroup()
402# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
403# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
404#
405# egetent(database, key)
406egetent() { 502egetent() {
407 case ${CHOST} in 503 case ${CHOST} in
408 *-darwin*) 504 *-darwin[678])
409 case "$2" in 505 case "$2" in
410 *[!0-9]*) # Non numeric 506 *[!0-9]*) # Non numeric
411 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 507 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
412 ;; 508 ;;
413 *) # Numeric 509 *) # Numeric
414 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 510 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
511 ;;
512 esac
513 ;;
514 *-darwin*)
515 local mytype=$1
516 [[ "passwd" == $mytype ]] && mytype="Users"
517 [[ "group" == $mytype ]] && mytype="Groups"
518 case "$2" in
519 *[!0-9]*) # Non numeric
520 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
521 ;;
522 *) # Numeric
523 local mykey="UniqueID"
524 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
525 dscl . -search /$mytype $mykey $2 2>/dev/null
415 ;; 526 ;;
416 esac 527 esac
417 ;; 528 ;;
418 *-freebsd*|*-dragonfly*) 529 *-freebsd*|*-dragonfly*)
419 local opts action="user" 530 local opts action="user"
434 getent "$1" "$2" 545 getent "$1" "$2"
435 ;; 546 ;;
436 esac 547 esac
437} 548}
438 549
439# Simplify/standardize adding users to the system 550# @FUNCTION: enewuser
440# vapier@gentoo.org 551# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
441# 552# @DESCRIPTION:
442# enewuser(username, uid, shell, homedir, groups, extra options) 553# Same as enewgroup, you are not required to understand how to properly add
443# 554# a user to the system. The only required parameter is the username.
444# Default values if you do not specify any: 555# Default uid is (pass -1 for this) next available, default shell is
445# username: REQUIRED ! 556# /bin/false, default homedir is /dev/null, there are no default groups,
446# uid: next available (see useradd(8)) 557# and default params sets the comment as 'added by portage for ${PN}'.
447# note: pass -1 to get default behavior
448# shell: /bin/false
449# homedir: /dev/null
450# groups: none
451# extra: comment of 'added by portage for ${PN}'
452enewuser() { 558enewuser() {
559 case ${EBUILD_PHASE} in
560 unpack|compile|test|install)
561 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
562 eerror "Package fails at QA and at life. Please file a bug."
563 die "Bad package! enewuser is only for use in pkg_* functions!"
564 esac
565
453 # get the username 566 # get the username
454 local euser=$1; shift 567 local euser=$1; shift
455 if [[ -z ${euser} ]] ; then 568 if [[ -z ${euser} ]] ; then
456 eerror "No username specified !" 569 eerror "No username specified !"
457 die "Cannot call enewuser without a username" 570 die "Cannot call enewuser without a username"
458 fi 571 fi
459 572
460 # lets see if the username already exists 573 # lets see if the username already exists
461 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 574 if [[ -n $(egetent passwd "${euser}") ]] ; then
462 return 0 575 return 0
463 fi 576 fi
464 einfo "Adding user '${euser}' to your system ..." 577 einfo "Adding user '${euser}' to your system ..."
465 578
466 # options to pass to useradd 579 # options to pass to useradd
467 local opts= 580 local opts=
468 581
469 # handle uid 582 # handle uid
470 local euid=$1; shift 583 local euid=$1; shift
471 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 584 if [[ -n ${euid} && ${euid} != -1 ]] ; then
472 if [[ ${euid} -gt 0 ]] ; then 585 if [[ ${euid} -gt 0 ]] ; then
473 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 586 if [[ -n $(egetent passwd ${euid}) ]] ; then
474 euid="next" 587 euid="next"
475 fi 588 fi
476 else 589 else
477 eerror "Userid given but is not greater than 0 !" 590 eerror "Userid given but is not greater than 0 !"
478 die "${euid} is not a valid UID" 591 die "${euid} is not a valid UID"
479 fi 592 fi
480 else 593 else
481 euid="next" 594 euid="next"
482 fi 595 fi
483 if [[ ${euid} == "next" ]] ; then 596 if [[ ${euid} == "next" ]] ; then
484 for euid in $(seq 101 999) ; do 597 for ((euid = 101; euid <= 999; euid++)); do
485 [[ -z $(egetent passwd ${euid}) ]] && break 598 [[ -z $(egetent passwd ${euid}) ]] && break
486 done 599 done
487 fi 600 fi
488 opts="${opts} -u ${euid}" 601 opts="${opts} -u ${euid}"
489 einfo " - Userid: ${euid}" 602 einfo " - Userid: ${euid}"
503 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 616 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
504 [[ -x ${ROOT}${shell} ]] && break 617 [[ -x ${ROOT}${shell} ]] && break
505 done 618 done
506 619
507 if [[ ${shell} == "/dev/null" ]] ; then 620 if [[ ${shell} == "/dev/null" ]] ; then
508 eerror "Unable to identify the shell to use" 621 eerror "Unable to identify the shell to use, proceeding with userland default."
509 die "Unable to identify the shell to use" 622 case ${USERLAND} in
623 GNU) shell="/bin/false" ;;
624 BSD) shell="/sbin/nologin" ;;
625 Darwin) shell="/usr/sbin/nologin" ;;
626 *) die "Unable to identify the default shell for userland ${USERLAND}"
627 esac
510 fi 628 fi
511 629
512 eshell=${shell} 630 eshell=${shell}
513 fi 631 fi
514 einfo " - Shell: ${eshell}" 632 einfo " - Shell: ${eshell}"
612 fi 730 fi
613 ;; 731 ;;
614 732
615 *) 733 *)
616 if [[ -z $@ ]] ; then 734 if [[ -z $@ ]] ; then
617 useradd ${opts} ${euser} \ 735 useradd -r ${opts} \
618 -c "added by portage for ${PN}" \ 736 -c "added by portage for ${PN}" \
737 ${euser} \
619 || die "enewuser failed" 738 || die "enewuser failed"
620 else 739 else
621 einfo " - Extra: $@" 740 einfo " - Extra: $@"
622 useradd ${opts} ${euser} "$@" \ 741 useradd -r ${opts} "$@" \
742 ${euser} \
623 || die "enewuser failed" 743 || die "enewuser failed"
624 fi 744 fi
625 ;; 745 ;;
626 esac 746 esac
627 747
633 fi 753 fi
634 754
635 export SANDBOX_ON=${oldsandbox} 755 export SANDBOX_ON=${oldsandbox}
636} 756}
637 757
638# Simplify/standardize adding groups to the system 758# @FUNCTION: enewgroup
639# vapier@gentoo.org 759# @USAGE: <group> [gid]
640# 760# @DESCRIPTION:
641# enewgroup(group, gid) 761# This function does not require you to understand how to properly add a
642# 762# group to the system. Just give it a group name to add and enewgroup will
643# Default values if you do not specify any: 763# do the rest. You may specify the gid for the group or allow the group to
644# groupname: REQUIRED ! 764# allocate the next available one.
645# gid: next available (see groupadd(8))
646# extra: none
647enewgroup() { 765enewgroup() {
766 case ${EBUILD_PHASE} in
767 unpack|compile|test|install)
768 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
769 eerror "Package fails at QA and at life. Please file a bug."
770 die "Bad package! enewgroup is only for use in pkg_* functions!"
771 esac
772
648 # get the group 773 # get the group
649 local egroup="$1"; shift 774 local egroup="$1"; shift
650 if [ -z "${egroup}" ] 775 if [ -z "${egroup}" ]
651 then 776 then
652 eerror "No group specified !" 777 eerror "No group specified !"
653 die "Cannot call enewgroup without a group" 778 die "Cannot call enewgroup without a group"
654 fi 779 fi
655 780
656 # see if group already exists 781 # see if group already exists
657 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 782 if [[ -n $(egetent group "${egroup}") ]]; then
658 then
659 return 0 783 return 0
660 fi 784 fi
661 einfo "Adding group '${egroup}' to your system ..." 785 einfo "Adding group '${egroup}' to your system ..."
662 786
663 # options to pass to useradd 787 # options to pass to useradd
706 fi 830 fi
707 831
708 # If we need the next available 832 # If we need the next available
709 case ${egid} in 833 case ${egid} in
710 *[!0-9]*) # Non numeric 834 *[!0-9]*) # Non numeric
711 for egid in $(seq 101 999); do 835 for ((egid = 101; egid <= 999; egid++)); do
712 [ -z "`egetent group ${egid}`" ] && break 836 [[ -z $(egetent group ${egid}) ]] && break
713 done 837 done
714 esac 838 esac
715 dscl . create /groups/${egroup} gid ${egid} 839 dscl . create /groups/${egroup} gid ${egid}
716 dscl . create /groups/${egroup} passwd '*' 840 dscl . create /groups/${egroup} passwd '*'
717 ;; 841 ;;
718 842
719 *-freebsd*|*-dragonfly*) 843 *-freebsd*|*-dragonfly*)
720 case ${egid} in 844 case ${egid} in
721 *[!0-9]*) # Non numeric 845 *[!0-9]*) # Non numeric
722 for egid in $(seq 101 999); do 846 for ((egid = 101; egid <= 999; egid++)); do
723 [ -z "`egetent group ${egid}`" ] && break 847 [[ -z $(egetent group ${egid}) ]] && break
724 done 848 done
725 esac 849 esac
726 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 850 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
727 ;; 851 ;;
728 852
729 *-netbsd*) 853 *-netbsd*)
730 case ${egid} in 854 case ${egid} in
731 *[!0-9]*) # Non numeric 855 *[!0-9]*) # Non numeric
732 for egid in $(seq 101 999); do 856 for ((egid = 101; egid <= 999; egid++)); do
733 [ -z "`egetent group ${egid}`" ] && break 857 [[ -z $(egetent group ${egid}) ]] && break
734 done 858 done
735 esac 859 esac
736 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 860 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
737 ;; 861 ;;
738 862
739 *) 863 *)
864 # We specify -r so that we get a GID in the system range from login.defs
740 groupadd ${opts} ${egroup} || die "enewgroup failed" 865 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
741 ;; 866 ;;
742 esac 867 esac
743 export SANDBOX_ON="${oldsandbox}" 868 export SANDBOX_ON="${oldsandbox}"
744} 869}
745 870
746# Simple script to replace 'dos2unix' binaries 871# @FUNCTION: edos2unix
747# vapier@gentoo.org 872# @USAGE: <file> [more files ...]
748# 873# @DESCRIPTION:
749# edos2unix(file, <more files> ...) 874# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
875# to remove all of these text utilities from DEPEND variables because this
876# is a script based solution. Just give it a list of files to convert and
877# they will all be changed from the DOS CRLF format to the UNIX LF format.
750edos2unix() { 878edos2unix() {
751 for f in "$@" 879 echo "$@" | xargs sed -i 's/\r$//'
752 do
753 cp "${f}" ${T}/edos2unix
754 sed 's/\r$//' ${T}/edos2unix > "${f}"
755 done
756} 880}
757
758
759##############################################################
760# START: Handle .desktop files and menu entries #
761# maybe this should be separated into a new eclass some time #
762# lanius@gentoo.org #
763##############################################################
764 881
765# Make a desktop file ! 882# Make a desktop file !
766# Great for making those icons in kde/gnome startmenu ! 883# Great for making those icons in kde/gnome startmenu !
767# Amaze your friends ! Get the women ! Join today ! 884# Amaze your friends ! Get the women ! Join today !
768# 885#
769# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 886# make_desktop_entry(<command>, [name], [icon], [type], [fields])
770# 887#
771# binary: what binary does the app run with ? 888# binary: what command does the app run with ?
772# name: the name that will show up in the menu 889# name: the name that will show up in the menu
773# icon: give your little like a pretty little icon ... 890# icon: give your little like a pretty little icon ...
774# this can be relative (to /usr/share/pixmaps) or 891# this can be relative (to /usr/share/pixmaps) or
775# a full path to an icon 892# a full path to an icon
776# type: what kind of application is this ? for categories: 893# type: what kind of application is this ? for categories:
777# http://www.freedesktop.org/Standards/desktop-entry-spec 894# http://standards.freedesktop.org/menu-spec/latest/apa.html
778# path: if your app needs to startup in a specific dir 895# fields: extra fields to append to the desktop file; a printf string
779make_desktop_entry() { 896make_desktop_entry() {
780 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 897 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
781 898
782 local exec=${1} 899 local exec=${1}
783 local name=${2:-${PN}} 900 local name=${2:-${PN}}
784 local icon=${3:-${PN}.png} 901 local icon=${3:-${PN}}
785 local type=${4} 902 local type=${4}
786 local path=${5} 903 local fields=${5}
787 904
788 if [[ -z ${type} ]] ; then 905 if [[ -z ${type} ]] ; then
789 local catmaj=${CATEGORY%%-*} 906 local catmaj=${CATEGORY%%-*}
790 local catmin=${CATEGORY##*-} 907 local catmin=${CATEGORY##*-}
791 case ${catmaj} in 908 case ${catmaj} in
792 app) 909 app)
793 case ${catmin} in 910 case ${catmin} in
911 accessibility) type=Accessibility;;
794 admin) type=System;; 912 admin) type=System;;
913 antivirus) type=System;;
914 arch) type=Archiving;;
915 backup) type=Archiving;;
795 cdr) type=DiscBurning;; 916 cdr) type=DiscBurning;;
796 dicts) type=Dictionary;; 917 dicts) type=Dictionary;;
918 doc) type=Documentation;;
797 editors) type=TextEditor;; 919 editors) type=TextEditor;;
798 emacs) type=TextEditor;; 920 emacs) type=TextEditor;;
799 emulation) type=Emulator;; 921 emulation) type=Emulator;;
800 laptop) type=HardwareSettings;; 922 laptop) type=HardwareSettings;;
801 office) type=Office;; 923 office) type=Office;;
924 pda) type=PDA;;
802 vim) type=TextEditor;; 925 vim) type=TextEditor;;
803 xemacs) type=TextEditor;; 926 xemacs) type=TextEditor;;
804 *) type=;;
805 esac 927 esac
806 ;; 928 ;;
807 929
808 dev) 930 dev)
809 type="Development" 931 type="Development"
810 ;; 932 ;;
811 933
812 games) 934 games)
813 case ${catmin} in 935 case ${catmin} in
814 action) type=ActionGame;; 936 action|fps) type=ActionGame;;
815 arcade) type=ArcadeGame;; 937 arcade) type=ArcadeGame;;
816 board) type=BoardGame;; 938 board) type=BoardGame;;
817 kid) type=KidsGame;;
818 emulation) type=Emulator;; 939 emulation) type=Emulator;;
940 kids) type=KidsGame;;
819 puzzle) type=LogicGame;; 941 puzzle) type=LogicGame;;
942 roguelike) type=RolePlaying;;
820 rpg) type=RolePlaying;; 943 rpg) type=RolePlaying;;
821 roguelike) type=RolePlaying;;
822 simulation) type=Simulation;; 944 simulation) type=Simulation;;
823 sports) type=SportsGame;; 945 sports) type=SportsGame;;
824 strategy) type=StrategyGame;; 946 strategy) type=StrategyGame;;
825 *) type=;;
826 esac 947 esac
827 type="Game;${type}" 948 type="Game;${type}"
828 ;; 949 ;;
829 950
951 gnome)
952 type="Gnome;GTK"
953 ;;
954
955 kde)
956 type="KDE;Qt"
957 ;;
958
830 mail) 959 mail)
831 type="Network;Email" 960 type="Network;Email"
832 ;; 961 ;;
833 962
834 media) 963 media)
835 case ${catmin} in 964 case ${catmin} in
965 gfx)
836 gfx) type=Graphics;; 966 type=Graphics
967 ;;
968 *)
969 case ${catmin} in
837 radio) type=Tuner;; 970 radio) type=Tuner;;
838 sound) type=Audio;; 971 sound) type=Audio;;
839 tv) type=TV;; 972 tv) type=TV;;
840 video) type=Video;; 973 video) type=Video;;
841 *) type=;; 974 esac
975 type="AudioVideo;${type}"
976 ;;
842 esac 977 esac
843 type="AudioVideo;${type}"
844 ;; 978 ;;
845 979
846 net) 980 net)
847 case ${catmin} in 981 case ${catmin} in
848 dialup) type=Dialup;; 982 dialup) type=Dialup;;
851 irc) type=IRCClient;; 985 irc) type=IRCClient;;
852 mail) type=Email;; 986 mail) type=Email;;
853 news) type=News;; 987 news) type=News;;
854 nntp) type=News;; 988 nntp) type=News;;
855 p2p) type=FileTransfer;; 989 p2p) type=FileTransfer;;
856 *) type=;; 990 voip) type=Telephony;;
857 esac 991 esac
858 type="Network;${type}" 992 type="Network;${type}"
859 ;; 993 ;;
860 994
861 sci) 995 sci)
862 case ${catmin} in 996 case ${catmin} in
863 astro*) type=Astronomy;; 997 astro*) type=Astronomy;;
864 bio*) type=Biology;; 998 bio*) type=Biology;;
865 calc*) type=Calculator;; 999 calc*) type=Calculator;;
866 chem*) type=Chemistry;; 1000 chem*) type=Chemistry;;
1001 elec*) type=Electronics;;
867 geo*) type=Geology;; 1002 geo*) type=Geology;;
868 math*) type=Math;; 1003 math*) type=Math;;
869 *) type=;; 1004 physics) type=Physics;;
1005 visual*) type=DataVisualization;;
870 esac 1006 esac
871 type="Science;${type}" 1007 type="Education;Science;${type}"
1008 ;;
1009
1010 sys)
1011 type="System"
872 ;; 1012 ;;
873 1013
874 www) 1014 www)
875 case ${catmin} in 1015 case ${catmin} in
876 client) type=WebBrowser;; 1016 client) type=WebBrowser;;
877 *) type=;;
878 esac 1017 esac
879 type="Network" 1018 type="Network;${type}"
880 ;; 1019 ;;
881 1020
882 *) 1021 *)
883 type= 1022 type=
884 ;; 1023 ;;
887 if [ "${SLOT}" == "0" ] ; then 1026 if [ "${SLOT}" == "0" ] ; then
888 local desktop_name="${PN}" 1027 local desktop_name="${PN}"
889 else 1028 else
890 local desktop_name="${PN}-${SLOT}" 1029 local desktop_name="${PN}-${SLOT}"
891 fi 1030 fi
1031 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
892 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1032 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
893 1033
1034 # Don't append another ";" when a valid category value is provided.
1035 type=${type%;}${type:+;}
1036
1037 eshopts_push -s extglob
1038 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1039 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1040 ewarn "allowed in .desktop files if the value is not an absolute path."
1041 icon=${icon%.@(xpm|png|svg)}
1042 fi
1043 eshopts_pop
1044
1045 cat <<-EOF > "${desktop}"
894echo "[Desktop Entry] 1046 [Desktop Entry]
895Encoding=UTF-8
896Version=0.9.2
897Name=${name} 1047 Name=${name}
898Type=Application 1048 Type=Application
899Comment=${DESCRIPTION} 1049 Comment=${DESCRIPTION}
900Exec=${exec} 1050 Exec=${exec}
901Path=${path} 1051 TryExec=${exec%% *}
902Icon=${icon} 1052 Icon=${icon}
903Categories=Application;${type};" > "${desktop}" 1053 Categories=${type}
1054 EOF
1055
1056 if [[ ${fields:-=} != *=* ]] ; then
1057 # 5th arg used to be value to Path=
1058 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1059 fields="Path=${fields}"
1060 fi
1061 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
904 1062
905 ( 1063 (
906 # wrap the env here so that the 'insinto' call 1064 # wrap the env here so that the 'insinto' call
907 # doesn't corrupt the env of the caller 1065 # doesn't corrupt the env of the caller
908 insinto /usr/share/applications 1066 insinto /usr/share/applications
909 doins "${desktop}" 1067 doins "${desktop}"
910 ) 1068 ) || die "installing desktop file failed"
911} 1069}
912 1070
913# Make a GDM/KDM Session file 1071# @FUNCTION: validate_desktop_entries
914# 1072# @USAGE: [directories]
915# make_desktop_entry(<title>, <command>) 1073# @MAINTAINER:
916# title: File to execute to start the Window Manager 1074# Carsten Lohrke <carlo@gentoo.org>
917# command: Name of the Window Manager 1075# @DESCRIPTION:
1076# Validate desktop entries using desktop-file-utils
1077validate_desktop_entries() {
1078 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1079 einfo "Checking desktop entry validity"
1080 local directories=""
1081 for d in /usr/share/applications $@ ; do
1082 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1083 done
1084 if [[ -n ${directories} ]] ; then
1085 for FILE in $(find ${directories} -name "*\.desktop" \
1086 -not -path '*.hidden*' | sort -u 2>/dev/null)
1087 do
1088 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1089 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1090 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1091 done
1092 fi
1093 echo ""
1094 else
1095 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1096 fi
1097}
918 1098
1099# @FUNCTION: make_session_desktop
1100# @USAGE: <title> <command> [command args...]
1101# @DESCRIPTION:
1102# Make a GDM/KDM Session file. The title is the file to execute to start the
1103# Window Manager. The command is the name of the Window Manager.
1104#
1105# You can set the name of the file via the ${wm} variable.
919make_session_desktop() { 1106make_session_desktop() {
920 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1107 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
921 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1108 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
922 1109
923 local title=$1 1110 local title=$1
924 local command=$2 1111 local command=$2
925 local desktop=${T}/${wm}.desktop 1112 local desktop=${T}/${wm:-${PN}}.desktop
1113 shift 2
926 1114
1115 cat <<-EOF > "${desktop}"
927echo "[Desktop Entry] 1116 [Desktop Entry]
928Encoding=UTF-8
929Name=${title} 1117 Name=${title}
930Comment=This session logs you into ${title} 1118 Comment=This session logs you into ${title}
931Exec=${command} 1119 Exec=${command} $*
932TryExec=${command} 1120 TryExec=${command}
933Type=Application" > "${desktop}" 1121 Type=XSession
1122 EOF
934 1123
1124 (
1125 # wrap the env here so that the 'insinto' call
1126 # doesn't corrupt the env of the caller
935 insinto /usr/share/xsessions 1127 insinto /usr/share/xsessions
936 doins "${desktop}" 1128 doins "${desktop}"
1129 )
937} 1130}
938 1131
1132# @FUNCTION: domenu
1133# @USAGE: <menus>
1134# @DESCRIPTION:
1135# Install the list of .desktop menu files into the appropriate directory
1136# (/usr/share/applications).
939domenu() { 1137domenu() {
1138 (
1139 # wrap the env here so that the 'insinto' call
1140 # doesn't corrupt the env of the caller
940 local i j 1141 local i j ret=0
941 insinto /usr/share/applications 1142 insinto /usr/share/applications
942 for i in "$@" ; do 1143 for i in "$@" ; do
943 if [[ -f ${i} ]] ; then 1144 if [[ -f ${i} ]] ; then
944 doins "${i}" 1145 doins "${i}"
1146 ((ret+=$?))
945 elif [[ -d ${i} ]] ; then 1147 elif [[ -d ${i} ]] ; then
946 for j in "${i}"/*.desktop ; do 1148 for j in "${i}"/*.desktop ; do
947 doins "${j}" 1149 doins "${j}"
1150 ((ret+=$?))
948 done 1151 done
1152 else
1153 ((++ret))
949 fi 1154 fi
950 done 1155 done
1156 exit ${ret}
1157 )
951} 1158}
1159
1160# @FUNCTION: newmenu
1161# @USAGE: <menu> <newname>
1162# @DESCRIPTION:
1163# Like all other new* functions, install the specified menu as newname.
952newmenu() { 1164newmenu() {
1165 (
1166 # wrap the env here so that the 'insinto' call
1167 # doesn't corrupt the env of the caller
953 insinto /usr/share/applications 1168 insinto /usr/share/applications
954 newins "$1" "$2" 1169 newins "$@"
1170 )
955} 1171}
956 1172
1173# @FUNCTION: doicon
1174# @USAGE: <list of icons>
1175# @DESCRIPTION:
1176# Install the list of icons into the icon directory (/usr/share/pixmaps).
1177# This is useful in conjunction with creating desktop/menu files.
957doicon() { 1178doicon() {
1179 (
1180 # wrap the env here so that the 'insinto' call
1181 # doesn't corrupt the env of the caller
958 local i j 1182 local i j ret
959 insinto /usr/share/pixmaps 1183 insinto /usr/share/pixmaps
960 for i in "$@" ; do 1184 for i in "$@" ; do
961 if [[ -f ${i} ]] ; then 1185 if [[ -f ${i} ]] ; then
962 doins "${i}" 1186 doins "${i}"
1187 ((ret+=$?))
963 elif [[ -d ${i} ]] ; then 1188 elif [[ -d ${i} ]] ; then
964 for j in "${i}"/*.png ; do 1189 for j in "${i}"/*.png ; do
965 doins "${j}" 1190 doins "${j}"
1191 ((ret+=$?))
966 done 1192 done
1193 else
1194 ((++ret))
967 fi 1195 fi
968 done 1196 done
1197 exit ${ret}
1198 )
969} 1199}
1200
1201# @FUNCTION: newicon
1202# @USAGE: <icon> <newname>
1203# @DESCRIPTION:
1204# Like all other new* functions, install the specified icon as newname.
970newicon() { 1205newicon() {
1206 (
1207 # wrap the env here so that the 'insinto' call
1208 # doesn't corrupt the env of the caller
971 insinto /usr/share/pixmaps 1209 insinto /usr/share/pixmaps
972 newins "$1" "$2" 1210 newins "$@"
1211 )
973} 1212}
974
975##############################################################
976# END: Handle .desktop files and menu entries #
977##############################################################
978
979 1213
980# for internal use only (unpack_pdv and unpack_makeself) 1214# for internal use only (unpack_pdv and unpack_makeself)
981find_unpackable_file() { 1215find_unpackable_file() {
982 local src=$1 1216 local src=$1
983 if [[ -z ${src} ]] ; then 1217 if [[ -z ${src} ]] ; then
993 fi 1227 fi
994 [[ ! -e ${src} ]] && return 1 1228 [[ ! -e ${src} ]] && return 1
995 echo "${src}" 1229 echo "${src}"
996} 1230}
997 1231
1232# @FUNCTION: unpack_pdv
1233# @USAGE: <file to unpack> <size of off_t>
1234# @DESCRIPTION:
998# Unpack those pesky pdv generated files ... 1235# Unpack those pesky pdv generated files ...
999# They're self-unpacking programs with the binary package stuffed in 1236# They're self-unpacking programs with the binary package stuffed in
1000# the middle of the archive. Valve seems to use it a lot ... too bad 1237# the middle of the archive. Valve seems to use it a lot ... too bad
1001# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1238# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1002# 1239#
1003# Usage: unpack_pdv [file to unpack] [size of off_t]
1004# - you have to specify the off_t size ... i have no idea how to extract that 1240# You have to specify the off_t size ... I have no idea how to extract that
1005# information out of the binary executable myself. basically you pass in 1241# information out of the binary executable myself. Basically you pass in
1006# the size of the off_t type (in bytes) on the machine that built the pdv 1242# the size of the off_t type (in bytes) on the machine that built the pdv
1243# archive.
1244#
1007# archive. one way to determine this is by running the following commands: 1245# One way to determine this is by running the following commands:
1246#
1247# @CODE
1008# strings <pdv archive> | grep lseek 1248# strings <pdv archive> | grep lseek
1009# strace -elseek <pdv archive> 1249# strace -elseek <pdv archive>
1250# @CODE
1251#
1010# basically look for the first lseek command (we do the strings/grep because 1252# Basically look for the first lseek command (we do the strings/grep because
1011# sometimes the function call is _llseek or something) and steal the 2nd 1253# sometimes the function call is _llseek or something) and steal the 2nd
1012# parameter. here is an example: 1254# parameter. Here is an example:
1255#
1256# @CODE
1013# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1257# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1014# lseek 1258# lseek
1015# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1259# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1016# lseek(3, -4, SEEK_END) = 2981250 1260# lseek(3, -4, SEEK_END) = 2981250
1261# @CODE
1262#
1017# thus we would pass in the value of '4' as the second parameter. 1263# Thus we would pass in the value of '4' as the second parameter.
1018unpack_pdv() { 1264unpack_pdv() {
1019 local src=$(find_unpackable_file $1) 1265 local src=$(find_unpackable_file "$1")
1020 local sizeoff_t=$2 1266 local sizeoff_t=$2
1021 1267
1022 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1268 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1023 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1269 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1024 1270
1025 local shrtsrc=$(basename "${src}") 1271 local shrtsrc=$(basename "${src}")
1026 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1272 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1027 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1273 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1028 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1274 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1029 1275
1030 # grab metadata for debug reasons 1276 # grab metadata for debug reasons
1031 local metafile="$(emktemp)" 1277 local metafile=$(emktemp)
1032 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1278 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1033 1279
1034 # rip out the final file name from the metadata 1280 # rip out the final file name from the metadata
1035 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1281 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1036 datafile="`basename ${datafile}`" 1282 datafile=$(basename "${datafile}")
1037 1283
1038 # now lets uncompress/untar the file if need be 1284 # now lets uncompress/untar the file if need be
1039 local tmpfile="$(emktemp)" 1285 local tmpfile=$(emktemp)
1040 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1286 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1041 1287
1042 local iscompressed="`file -b ${tmpfile}`" 1288 local iscompressed=$(file -b "${tmpfile}")
1043 if [ "${iscompressed:0:8}" == "compress" ] ; then 1289 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1044 iscompressed=1 1290 iscompressed=1
1045 mv ${tmpfile}{,.Z} 1291 mv ${tmpfile}{,.Z}
1046 gunzip ${tmpfile} 1292 gunzip ${tmpfile}
1047 else 1293 else
1048 iscompressed=0 1294 iscompressed=0
1049 fi 1295 fi
1050 local istar="`file -b ${tmpfile}`" 1296 local istar=$(file -b "${tmpfile}")
1051 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1297 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1052 istar=1 1298 istar=1
1053 else 1299 else
1054 istar=0 1300 istar=0
1055 fi 1301 fi
1056 1302
1084 true 1330 true
1085 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1331 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1086 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1332 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1087} 1333}
1088 1334
1335# @FUNCTION: unpack_makeself
1336# @USAGE: [file to unpack] [offset] [tail|dd]
1337# @DESCRIPTION:
1089# Unpack those pesky makeself generated files ... 1338# Unpack those pesky makeself generated files ...
1090# They're shell scripts with the binary package tagged onto 1339# They're shell scripts with the binary package tagged onto
1091# the end of the archive. Loki utilized the format as does 1340# the end of the archive. Loki utilized the format as does
1092# many other game companies. 1341# many other game companies.
1093# 1342#
1094# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1343# If the file is not specified, then ${A} is used. If the
1095# - If the file is not specified then unpack will utilize ${A}.
1096# - If the offset is not specified then we will attempt to extract 1344# offset is not specified then we will attempt to extract
1097# the proper offset from the script itself. 1345# the proper offset from the script itself.
1098unpack_makeself() { 1346unpack_makeself() {
1099 local src_input=${1:-${A}} 1347 local src_input=${1:-${A}}
1100 local src=$(find_unpackable_file "${src_input}") 1348 local src=$(find_unpackable_file "${src_input}")
1101 local skip=$2 1349 local skip=$2
1102 local exe=$3 1350 local exe=$3
1104 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1352 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1105 1353
1106 local shrtsrc=$(basename "${src}") 1354 local shrtsrc=$(basename "${src}")
1107 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1355 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1108 if [[ -z ${skip} ]] ; then 1356 if [[ -z ${skip} ]] ; then
1109 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1357 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1110 local skip=0 1358 local skip=0
1111 exe=tail 1359 exe=tail
1112 case ${ver} in 1360 case ${ver} in
1113 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1361 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1114 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1362 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1115 ;; 1363 ;;
1116 2.0|2.0.1) 1364 2.0|2.0.1)
1117 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1365 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1118 ;; 1366 ;;
1119 2.1.1) 1367 2.1.1)
1120 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1368 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1121 let skip="skip + 1" 1369 (( skip++ ))
1122 ;; 1370 ;;
1123 2.1.2) 1371 2.1.2)
1124 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1372 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1125 let skip="skip + 1" 1373 (( skip++ ))
1126 ;; 1374 ;;
1127 2.1.3) 1375 2.1.3)
1128 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1376 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1129 let skip="skip + 1" 1377 (( skip++ ))
1130 ;; 1378 ;;
1131 2.1.4|2.1.5) 1379 2.1.4|2.1.5)
1132 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1380 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1133 skip=$(head -n ${skip} "${src}" | wc -c) 1381 skip=$(head -n ${skip} "${src}" | wc -c)
1134 exe="dd" 1382 exe="dd"
1143 esac 1391 esac
1144 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1392 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1145 fi 1393 fi
1146 case ${exe} in 1394 case ${exe} in
1147 tail) exe="tail -n +${skip} '${src}'";; 1395 tail) exe="tail -n +${skip} '${src}'";;
1148 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1396 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1149 *) die "makeself cant handle exe '${exe}'" 1397 *) die "makeself cant handle exe '${exe}'"
1150 esac 1398 esac
1151 1399
1152 # lets grab the first few bytes of the file to figure out what kind of archive it is 1400 # lets grab the first few bytes of the file to figure out what kind of archive it is
1153 local tmpfile="$(emktemp)" 1401 local filetype tmpfile=$(emktemp)
1154 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1402 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1155 local filetype="$(file -b "${tmpfile}")" 1403 filetype=$(file -b "${tmpfile}") || die
1156 case ${filetype} in 1404 case ${filetype} in
1157 *tar\ archive) 1405 *tar\ archive*)
1158 eval ${exe} | tar --no-same-owner -xf - 1406 eval ${exe} | tar --no-same-owner -xf -
1159 ;; 1407 ;;
1160 bzip2*) 1408 bzip2*)
1161 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1409 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1162 ;; 1410 ;;
1172 ;; 1420 ;;
1173 esac 1421 esac
1174 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1422 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1175} 1423}
1176 1424
1425# @FUNCTION: check_license
1426# @USAGE: [license]
1427# @DESCRIPTION:
1177# Display a license for user to accept. 1428# Display a license for user to accept. If no license is
1178#
1179# Usage: check_license [license]
1180# - If the file is not specified then ${LICENSE} is used. 1429# specified, then ${LICENSE} is used.
1181check_license() { 1430check_license() {
1182 local lic=$1 1431 local lic=$1
1183 if [ -z "${lic}" ] ; then 1432 if [ -z "${lic}" ] ; then
1184 lic="${PORTDIR}/licenses/${LICENSE}" 1433 lic="${PORTDIR}/licenses/${LICENSE}"
1185 else 1434 else
1189 lic="${PWD}/${lic}" 1438 lic="${PWD}/${lic}"
1190 elif [ -e "${lic}" ] ; then 1439 elif [ -e "${lic}" ] ; then
1191 lic="${lic}" 1440 lic="${lic}"
1192 fi 1441 fi
1193 fi 1442 fi
1194 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1195 local l="`basename ${lic}`" 1443 local l="`basename ${lic}`"
1196 1444
1197 # here is where we check for the licenses the user already 1445 # here is where we check for the licenses the user already
1198 # accepted ... if we don't find a match, we make the user accept 1446 # accepted ... if we don't find a match, we make the user accept
1199 local shopts=$-
1200 local alic 1447 local alic
1201 set -o noglob #so that bash doesn't expand "*" 1448 eshopts_push -o noglob # so that bash doesn't expand "*"
1202 for alic in ${ACCEPT_LICENSE} ; do 1449 for alic in ${ACCEPT_LICENSE} ; do
1203 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1450 if [[ ${alic} == ${l} ]]; then
1204 set +o noglob; set -${shopts} #reset old shell opts 1451 eshopts_pop
1205 return 0 1452 return 0
1206 fi 1453 fi
1207 done 1454 done
1208 set +o noglob; set -$shopts #reset old shell opts 1455 eshopts_pop
1456 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1209 1457
1210 local licmsg="$(emktemp)" 1458 local licmsg=$(emktemp)
1211 cat << EOF > ${licmsg} 1459 cat <<-EOF > ${licmsg}
1212********************************************************** 1460 **********************************************************
1213The following license outlines the terms of use of this 1461 The following license outlines the terms of use of this
1214package. You MUST accept this license for installation to 1462 package. You MUST accept this license for installation to
1215continue. When you are done viewing, hit 'q'. If you 1463 continue. When you are done viewing, hit 'q'. If you
1216CTRL+C out of this, the install will not run! 1464 CTRL+C out of this, the install will not run!
1217********************************************************** 1465 **********************************************************
1218 1466
1219EOF 1467 EOF
1220 cat ${lic} >> ${licmsg} 1468 cat ${lic} >> ${licmsg}
1221 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1469 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1222 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1470 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1223 read alic 1471 read alic
1224 case ${alic} in 1472 case ${alic} in
1231 die "Failed to accept license" 1479 die "Failed to accept license"
1232 ;; 1480 ;;
1233 esac 1481 esac
1234} 1482}
1235 1483
1484# @FUNCTION: cdrom_get_cds
1485# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1486# @DESCRIPTION:
1236# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1487# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1237# the whole 'non-interactive' policy, but damnit I want CD support ! 1488# the whole 'non-interactive' policy, but damnit I want CD support !
1238# 1489#
1239# with these cdrom functions we handle all the user interaction and 1490# With these cdrom functions we handle all the user interaction and
1240# standardize everything. all you have to do is call cdrom_get_cds() 1491# standardize everything. All you have to do is call cdrom_get_cds()
1241# and when the function returns, you can assume that the cd has been 1492# and when the function returns, you can assume that the cd has been
1242# found at CDROM_ROOT. 1493# found at CDROM_ROOT.
1243# 1494#
1495# The function will attempt to locate a cd based upon a file that is on
1496# the cd. The more files you give this function, the more cds
1497# the cdrom functions will handle.
1498#
1244# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1499# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1245# etc... if you want to give the cds better names, then just export 1500# etc... If you want to give the cds better names, then just export
1246# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1501# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1502# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1503# also use the CDROM_NAME_SET bash array.
1247# 1504#
1248# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1505# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1249#
1250# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1251# - this will attempt to locate a cd based upon a file that is on
1252# the cd ... the more files you give this function, the more cds
1253# the cdrom functions will handle
1254cdrom_get_cds() { 1506cdrom_get_cds() {
1255 # first we figure out how many cds we're dealing with by 1507 # first we figure out how many cds we're dealing with by
1256 # the # of files they gave us 1508 # the # of files they gave us
1257 local cdcnt=0 1509 local cdcnt=0
1258 local f= 1510 local f=
1282 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1534 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1283 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1535 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1284 export CDROM_SET=-1 1536 export CDROM_SET=-1
1285 for f in ${CDROM_CHECK_1//:/ } ; do 1537 for f in ${CDROM_CHECK_1//:/ } ; do
1286 ((++CDROM_SET)) 1538 ((++CDROM_SET))
1287 [[ -e ${CD_ROOT}/${f} ]] && break 1539 [[ -e ${CDROM_ROOT}/${f} ]] && break
1288 done 1540 done
1289 export CDROM_MATCH=${f} 1541 export CDROM_MATCH=${f}
1290 return 1542 return
1291 fi 1543 fi
1292 1544
1302 echo 1554 echo
1303 einfo "For example:" 1555 einfo "For example:"
1304 einfo "export CD_ROOT=/mnt/cdrom" 1556 einfo "export CD_ROOT=/mnt/cdrom"
1305 echo 1557 echo
1306 else 1558 else
1559 if [[ -n ${CDROM_NAME_SET} ]] ; then
1560 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1561 cdcnt=0
1562 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1563 ((++cdcnt))
1564 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1565 done
1566 fi
1567
1307 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1568 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1308 cdcnt=0 1569 cdcnt=0
1309 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1570 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1310 ((++cdcnt)) 1571 ((++cdcnt))
1311 var="CDROM_NAME_${cdcnt}" 1572 var="CDROM_NAME_${cdcnt}"
1335 export CDROM_SET="" 1596 export CDROM_SET=""
1336 export CDROM_CURRENT_CD=0 1597 export CDROM_CURRENT_CD=0
1337 cdrom_load_next_cd 1598 cdrom_load_next_cd
1338} 1599}
1339 1600
1340# this is only used when you need access to more than one cd. 1601# @FUNCTION: cdrom_load_next_cd
1341# when you have finished using the first cd, just call this function. 1602# @DESCRIPTION:
1342# when it returns, CDROM_ROOT will be pointing to the second cd. 1603# Some packages are so big they come on multiple CDs. When you're done reading
1343# remember, you can only go forward in the cd chain, you can't go back. 1604# files off a CD and want access to the next one, just call this function.
1605# Again, all the messy details of user interaction are taken care of for you.
1606# Once this returns, just read the variable CDROM_ROOT for the location of the
1607# mounted CD. Note that you can only go forward in the CD list, so make sure
1608# you only call this function when you're done using the current CD.
1344cdrom_load_next_cd() { 1609cdrom_load_next_cd() {
1345 local var 1610 local var
1346 ((++CDROM_CURRENT_CD)) 1611 ((++CDROM_CURRENT_CD))
1347 1612
1348 unset CDROM_ROOT 1613 unset CDROM_ROOT
1365# displayed and we'll hang out here until: 1630# displayed and we'll hang out here until:
1366# (1) the file is found on a mounted cdrom 1631# (1) the file is found on a mounted cdrom
1367# (2) the user hits CTRL+C 1632# (2) the user hits CTRL+C
1368_cdrom_locate_file_on_cd() { 1633_cdrom_locate_file_on_cd() {
1369 local mline="" 1634 local mline=""
1370 local showedmsg=0 1635 local showedmsg=0 showjolietmsg=0
1371 1636
1372 while [[ -z ${CDROM_ROOT} ]] ; do 1637 while [[ -z ${CDROM_ROOT} ]] ; do
1373 local i=0 1638 local i=0
1374 local -a cdset=(${*//:/ }) 1639 local -a cdset=(${*//:/ })
1375 if [[ -n ${CDROM_SET} ]] ; then 1640 if [[ -n ${CDROM_SET} ]] ; then
1378 1643
1379 while [[ -n ${cdset[${i}]} ]] ; do 1644 while [[ -n ${cdset[${i}]} ]] ; do
1380 local dir=$(dirname ${cdset[${i}]}) 1645 local dir=$(dirname ${cdset[${i}]})
1381 local file=$(basename ${cdset[${i}]}) 1646 local file=$(basename ${cdset[${i}]})
1382 1647
1383 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1648 local point= node= fs= foo=
1649 while read point node fs foo ; do
1650 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1651 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1652 && continue
1653 point=${point//\040/ }
1384 [[ -d ${mline}/${dir} ]] || continue 1654 [[ ! -d ${point}/${dir} ]] && continue
1385 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1655 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1386 export CDROM_ROOT=${mline} 1656 export CDROM_ROOT=${point}
1387 export CDROM_SET=${i} 1657 export CDROM_SET=${i}
1388 export CDROM_MATCH=${cdset[${i}]} 1658 export CDROM_MATCH=${cdset[${i}]}
1389 return 1659 return
1390 fi 1660 done <<< "$(get_mounts)"
1391 done
1392 1661
1393 ((++i)) 1662 ((++i))
1394 done 1663 done
1395 1664
1396 echo 1665 echo
1412 showedmsg=1 1681 showedmsg=1
1413 fi 1682 fi
1414 einfo "Press return to scan for the cd again" 1683 einfo "Press return to scan for the cd again"
1415 einfo "or hit CTRL+C to abort the emerge." 1684 einfo "or hit CTRL+C to abort the emerge."
1416 echo 1685 echo
1686 if [[ ${showjolietmsg} -eq 0 ]] ; then
1687 showjolietmsg=1
1688 else
1417 einfo "If you are having trouble with the detection" 1689 ewarn "If you are having trouble with the detection"
1418 einfo "of your CD, it is possible that you do not have" 1690 ewarn "of your CD, it is possible that you do not have"
1419 einfo "Joliet support enabled in your kernel. Please" 1691 ewarn "Joliet support enabled in your kernel. Please"
1420 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1692 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1693 ebeep 5
1694 fi
1421 read || die "something is screwed with your system" 1695 read || die "something is screwed with your system"
1422 done 1696 done
1423} 1697}
1424 1698
1699# @FUNCTION: strip-linguas
1700# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1701# @DESCRIPTION:
1425# Make sure that LINGUAS only contains languages that 1702# Make sure that LINGUAS only contains languages that
1426# a package can support 1703# a package can support. The first form allows you to
1427# 1704# specify a list of LINGUAS. The -i builds a list of po
1428# usage: strip-linguas <allow LINGUAS> 1705# files found in all the directories and uses the
1429# strip-linguas -i <directories of .po files> 1706# intersection of the lists. The -u builds a list of po
1430# strip-linguas -u <directories of .po files> 1707# files found in all the directories and uses the union
1431# 1708# of the lists.
1432# The first form allows you to specify a list of LINGUAS.
1433# The -i builds a list of po files found in all the
1434# directories and uses the intersection of the lists.
1435# The -u builds a list of po files found in all the
1436# directories and uses the union of the lists.
1437strip-linguas() { 1709strip-linguas() {
1438 local ls newls 1710 local ls newls nols
1439 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1711 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1440 local op=$1; shift 1712 local op=$1; shift
1441 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1713 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1442 local d f 1714 local d f
1443 for d in "$@" ; do 1715 for d in "$@" ; do
1444 if [[ ${op} == "-u" ]] ; then 1716 if [[ ${op} == "-u" ]] ; then
1445 newls=${ls} 1717 newls=${ls}
1446 else 1718 else
1447 newls="" 1719 newls=""
1448 fi 1720 fi
1449 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1721 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1450 if [[ ${op} == "-i" ]] ; then 1722 if [[ ${op} == "-i" ]] ; then
1451 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1723 has ${f} ${ls} && newls="${newls} ${f}"
1452 else 1724 else
1453 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1725 has ${f} ${ls} || newls="${newls} ${f}"
1454 fi 1726 fi
1455 done 1727 done
1456 ls=${newls} 1728 ls=${newls}
1457 done 1729 done
1458 ls=${ls//.po}
1459 else 1730 else
1460 ls=$@ 1731 ls="$@"
1461 fi 1732 fi
1462 1733
1463 ls=" ${ls} " 1734 nols=""
1464 newls="" 1735 newls=""
1465 for f in ${LINGUAS} ; do 1736 for f in ${LINGUAS} ; do
1466 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1737 if has ${f} ${ls} ; then
1467 newls="${newls} ${f}" 1738 newls="${newls} ${f}"
1468 else 1739 else
1469 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1740 nols="${nols} ${f}"
1470 fi 1741 fi
1471 done 1742 done
1472 if [[ -z ${newls} ]] ; then 1743 [[ -n ${nols} ]] \
1473 export LINGUAS="" 1744 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1474 else
1475 export LINGUAS=${newls:1} 1745 export LINGUAS=${newls:1}
1476 fi
1477} 1746}
1478 1747
1479# moved from kernel.eclass since they are generally useful outside of 1748# @FUNCTION: preserve_old_lib
1480# kernel.eclass -iggy (20041002) 1749# @USAGE: <libs to preserve> [more libs]
1481 1750# @DESCRIPTION:
1482# the following functions are useful in kernel module ebuilds, etc.
1483# for an example see ivtv or drbd ebuilds
1484
1485# set's ARCH to match what the kernel expects
1486set_arch_to_kernel() {
1487 i=10
1488 while ((i--)) ; do
1489 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1490 done
1491 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1492 case ${ARCH} in
1493 x86) export ARCH="i386";;
1494 amd64) export ARCH="x86_64";;
1495 hppa) export ARCH="parisc";;
1496 mips) export ARCH="mips";;
1497 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1498 *) export ARCH="${ARCH}";;
1499 esac
1500}
1501
1502# set's ARCH back to what portage expects
1503set_arch_to_portage() {
1504 i=10
1505 while ((i--)) ; do
1506 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1507 done
1508 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1509}
1510
1511# Jeremy Huddleston <eradicator@gentoo.org>:
1512# preserve_old_lib /path/to/libblah.so.0
1513# preserve_old_lib_notify /path/to/libblah.so.0
1514#
1515# These functions are useful when a lib in your package changes --soname. Such 1751# These functions are useful when a lib in your package changes ABI SONAME.
1516# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1752# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1517# would break packages that link against it. Most people get around this 1753# would break packages that link against it. Most people get around this
1518# by using the portage SLOT mechanism, but that is not always a relevant 1754# by using the portage SLOT mechanism, but that is not always a relevant
1519# solution, so instead you can add the following to your ebuilds: 1755# solution, so instead you can call this from pkg_preinst. See also the
1520# 1756# preserve_old_lib_notify function.
1521# src_install() {
1522# ...
1523# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1524# ...
1525# }
1526#
1527# pkg_postinst() {
1528# ...
1529# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1530# ...
1531# }
1532
1533preserve_old_lib() { 1757preserve_old_lib() {
1534 LIB=$1 1758 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1759 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1760 die "Invalid preserve_old_lib() usage"
1761 fi
1762 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1535 1763
1536 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1764 # let portage worry about it
1537 SONAME=`basename ${LIB}` 1765 has preserve-libs ${FEATURES} && return 0
1538 DIRNAME=`dirname ${LIB}`
1539 1766
1540 dodir ${DIRNAME} 1767 local lib dir
1541 cp ${ROOT}${LIB} ${D}${DIRNAME} 1768 for lib in "$@" ; do
1769 [[ -e ${ROOT}/${lib} ]] || continue
1770 dir=${lib%/*}
1771 dodir ${dir} || die "dodir ${dir} failed"
1772 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1542 touch ${D}${LIB} 1773 touch "${D}"/${lib}
1543 fi 1774 done
1544} 1775}
1545 1776
1777# @FUNCTION: preserve_old_lib_notify
1778# @USAGE: <libs to notify> [more libs]
1779# @DESCRIPTION:
1780# Spit helpful messages about the libraries preserved by preserve_old_lib.
1546preserve_old_lib_notify() { 1781preserve_old_lib_notify() {
1547 LIB=$1 1782 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1783 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1784 die "Invalid preserve_old_lib_notify() usage"
1785 fi
1548 1786
1549 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1787 # let portage worry about it
1550 SONAME=`basename ${LIB}` 1788 has preserve-libs ${FEATURES} && return 0
1551 1789
1790 local lib notice=0
1791 for lib in "$@" ; do
1792 [[ -e ${ROOT}/${lib} ]] || continue
1793 if [[ ${notice} -eq 0 ]] ; then
1794 notice=1
1552 ewarn "An old version of an installed library was detected on your system." 1795 ewarn "Old versions of installed libraries were detected on your system."
1553 ewarn "In order to avoid breaking packages that link against it, this older version" 1796 ewarn "In order to avoid breaking packages that depend on these old libs,"
1554 ewarn "is not being removed. In order to make full use of this newer version," 1797 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1555 ewarn "you will need to execute the following command:" 1798 ewarn "in order to remove these old dependencies. If you do not have this"
1556 ewarn " revdep-rebuild --soname ${SONAME}" 1799 ewarn "helper program, simply emerge the 'gentoolkit' package."
1800 ewarn
1801 fi
1802 # temp hack for #348634 #357225
1803 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1804 ewarn " # revdep-rebuild --library '${lib}'"
1805 done
1806 if [[ ${notice} -eq 1 ]] ; then
1557 ewarn 1807 ewarn
1558 ewarn "After doing that, you can safely remove ${LIB}" 1808 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1559 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1809 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1810 for lib in "$@" ; do
1811 ewarn " # rm '${lib}'"
1812 done
1560 fi 1813 fi
1561} 1814}
1562 1815
1563# Hack for people to figure out if a package was built with 1816# @FUNCTION: built_with_use
1564# certain USE flags 1817# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1818# @DESCRIPTION:
1565# 1819#
1566# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1820# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1567# ex: built_with_use xchat gtk2
1568# 1821#
1569# Flags: -a all USE flags should be utilized 1822# A temporary hack until portage properly supports DEPENDing on USE
1570# -o at least one USE flag should be utilized 1823# flags being enabled in packages. This will check to see if the specified
1571# Note: the default flag is '-a' 1824# DEPEND atom was built with the specified list of USE flags. The
1825# --missing option controls the behavior if called on a package that does
1826# not actually support the defined USE flags (aka listed in IUSE).
1827# The default is to abort (call die). The -a and -o flags control
1828# the requirements of the USE flags. They correspond to "and" and "or"
1829# logic. So the -a flag means all listed USE flags must be enabled
1830# while the -o flag means at least one of the listed IUSE flags must be
1831# enabled. The --hidden option is really for internal use only as it
1832# means the USE flag we're checking is hidden expanded, so it won't be found
1833# in IUSE like normal USE flags.
1834#
1835# Remember that this function isn't terribly intelligent so order of optional
1836# flags matter.
1572built_with_use() { 1837built_with_use() {
1838 local hidden="no"
1839 if [[ $1 == "--hidden" ]] ; then
1840 hidden="yes"
1841 shift
1842 fi
1843
1844 local missing_action="die"
1845 if [[ $1 == "--missing" ]] ; then
1846 missing_action=$2
1847 shift ; shift
1848 case ${missing_action} in
1849 true|false|die) ;;
1850 *) die "unknown action '${missing_action}'";;
1851 esac
1852 fi
1853
1573 local opt=$1 1854 local opt=$1
1574 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1855 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1575 1856
1576 local PKG=$(best_version $1) 1857 local PKG=$(best_version $1)
1858 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1577 shift 1859 shift
1578 1860
1579 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1861 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1862 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1580 1863
1581 # if the USE file doesnt exist, assume the $PKG is either 1864 # if the IUSE file doesn't exist, the read will error out, we need to handle
1582 # injected or package.provided 1865 # this gracefully
1583 [[ ! -e ${USEFILE} ]] && return 0 1866 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1867 case ${missing_action} in
1868 true) return 0;;
1869 false) return 1;;
1870 die) die "Unable to determine what USE flags $PKG was built with";;
1871 esac
1872 fi
1873
1874 if [[ ${hidden} == "no" ]] ; then
1875 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1876 # Don't check USE_EXPAND #147237
1877 local expand
1878 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1879 if [[ $1 == ${expand}_* ]] ; then
1880 expand=""
1881 break
1882 fi
1883 done
1884 if [[ -n ${expand} ]] ; then
1885 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1886 case ${missing_action} in
1887 true) return 0;;
1888 false) return 1;;
1889 die) die "$PKG does not actually support the $1 USE flag!";;
1890 esac
1891 fi
1892 fi
1893 fi
1584 1894
1585 local USE_BUILT=$(<${USEFILE}) 1895 local USE_BUILT=$(<${USEFILE})
1586 while [[ $# -gt 0 ]] ; do 1896 while [[ $# -gt 0 ]] ; do
1587 if [[ ${opt} = "-o" ]] ; then 1897 if [[ ${opt} = "-o" ]] ; then
1588 has $1 ${USE_BUILT} && return 0 1898 has $1 ${USE_BUILT} && return 0
1592 shift 1902 shift
1593 done 1903 done
1594 [[ ${opt} = "-a" ]] 1904 [[ ${opt} = "-a" ]]
1595} 1905}
1596 1906
1907# @FUNCTION: epunt_cxx
1908# @USAGE: [dir to scan]
1909# @DESCRIPTION:
1597# Many configure scripts wrongly bail when a C++ compiler 1910# Many configure scripts wrongly bail when a C++ compiler could not be
1598# could not be detected. #73450 1911# detected. If dir is not specified, then it defaults to ${S}.
1912#
1913# http://bugs.gentoo.org/73450
1599epunt_cxx() { 1914epunt_cxx() {
1600 local dir=$1 1915 local dir=$1
1601 [[ -z ${dir} ]] && dir=${S} 1916 [[ -z ${dir} ]] && dir=${S}
1602 ebegin "Removing useless C++ checks" 1917 ebegin "Removing useless C++ checks"
1603 local f 1918 local f
1604 for f in $(find ${dir} -name configure) ; do 1919 find "${dir}" -name configure | while read f ; do
1605 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1920 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1606 done 1921 done
1607 eend 0 1922 eend 0
1608} 1923}
1609 1924
1610# dopamd <file> [more files] 1925# @FUNCTION: make_wrapper
1611# 1926# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1612# Install pam auth config file in /etc/pam.d 1927# @DESCRIPTION:
1613dopamd() { 1928# Create a shell wrapper script named wrapper in installpath
1614 [[ -z $1 ]] && die "dopamd requires at least one argument" 1929# (defaults to the bindir) to execute target (default of wrapper) by
1615 1930# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1616 use pam || return 0 1931# libpaths followed by optionally changing directory to chdir.
1617
1618 INSDESTTREE=/etc/pam.d \
1619 doins "$@" || die "failed to install $@"
1620}
1621# newpamd <old name> <new name>
1622#
1623# Install pam file <old name> as <new name> in /etc/pam.d
1624newpamd() {
1625 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1626
1627 use pam || return 0
1628
1629 INSDESTTREE=/etc/pam.d \
1630 newins "$1" "$2" || die "failed to install $1 as $2"
1631}
1632
1633# make a wrapper script ...
1634# NOTE: this was originally games_make_wrapper, but I noticed other places where
1635# this could be used, so I have moved it here and made it not games-specific
1636# -- wolf31o2
1637# $1 == wrapper name
1638# $2 == binary to run
1639# $3 == directory to chdir before running binary
1640# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1641# $5 == path for wrapper
1642make_wrapper() { 1932make_wrapper() {
1643 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1933 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1644 local tmpwrapper=$(emktemp) 1934 local tmpwrapper=$(emktemp)
1645 # We don't want to quote ${bin} so that people can pass complex 1935 # We don't want to quote ${bin} so that people can pass complex
1646 # things as $bin ... "./someprog --args" 1936 # things as $bin ... "./someprog --args"
1656fi 1946fi
1657exec ${bin} "\$@" 1947exec ${bin} "\$@"
1658EOF 1948EOF
1659 chmod go+rx "${tmpwrapper}" 1949 chmod go+rx "${tmpwrapper}"
1660 if [[ -n ${path} ]] ; then 1950 if [[ -n ${path} ]] ; then
1951 (
1661 exeinto "${path}" 1952 exeinto "${path}"
1662 newexe "${tmpwrapper}" "${wrapper}" 1953 newexe "${tmpwrapper}" "${wrapper}"
1954 ) || die
1663 else 1955 else
1664 newbin "${tmpwrapper}" "${wrapper}" 1956 newbin "${tmpwrapper}" "${wrapper}" || die
1665 fi 1957 fi
1666} 1958}
1959
1960# @FUNCTION: path_exists
1961# @USAGE: [-a|-o] <paths>
1962# @DESCRIPTION:
1963# Check if the specified paths exist. Works for all types of paths
1964# (files/dirs/etc...). The -a and -o flags control the requirements
1965# of the paths. They correspond to "and" and "or" logic. So the -a
1966# flag means all the paths must exist while the -o flag means at least
1967# one of the paths must exist. The default behavior is "and". If no
1968# paths are specified, then the return value is "false".
1969path_exists() {
1970 local opt=$1
1971 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1972
1973 # no paths -> return false
1974 # same behavior as: [[ -e "" ]]
1975 [[ $# -eq 0 ]] && return 1
1976
1977 local p r=0
1978 for p in "$@" ; do
1979 [[ -e ${p} ]]
1980 : $(( r += $? ))
1981 done
1982
1983 case ${opt} in
1984 -a) return $(( r != 0 )) ;;
1985 -o) return $(( r == $# )) ;;
1986 esac
1987}

Legend:
Removed from v.1.225  
changed lines
  Added in v.1.359

  ViewVC Help
Powered by ViewVC 1.1.20